<?php
// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

// parse bbcode tags to html on message mersing
$plugins->add_hook("parse_message", "bbcode_spoiler_parse_message");

// filter quoted messages for tags that user should not see
$plugins->add_hook('newreply_end', 'bbcode_spoiler_newreply_end');
// filter fast reply quoted messages
$plugins->add_hook('xmlhttp', 'bbcode_spoiler_xmlhttp');

function bbcode_spoiler_info() {
	return array(
		"name"			=> "BBCode Spoilers tags",
		"description"	=> "BBCode Spoilers tags addition for MyCode",
		"website"		=> "http://forum.omsk.ru",
		"author"		=> "krig",
		"authorsite"	=> "http://forum.omsk.ru",
		"version"		=> "0.5",
		"guid" 			=> "",
		"compatibility" => "14*",
	);
}

function bbcode_spoiler_parse_message($message) {
	$tags = array();
	$tags['\[spoiler\](.*?)\[/spoiler\]'] = 'bbcode_spoiler_replacement(trim("$1"))';
	$tags['\[spoiler=(.*?)\](.*?)\[/spoiler\]'] = 'bbcode_spoiler_replacement(trim("$2"), "$1")';
	$tags['\[member\](.*?)\[/member\]'] = 'bbcode_spoiler_member_replacement(trim("$1"))';
	$tags['\[member=(\d+)\](.*?)\[/member\]'] = 'bbcode_spoiler_member_replacement(trim("$2"), "$1")';
	$tags['\[moder\](.*?)\[/moder\]'] = 'bbcode_spoiler_moder_replacement(trim("$1"))';

	foreach ($tags as $pattern => $replacement) {
		$message = preg_replace('#' . $pattern . '#esi', $replacement, $message);
	}

	return $message;
}

function bbcode_spoiler_replacement($text, $caption = 'spoiler') {
	$id = 'spoiler_box_' . uniqid();

	$out = <<<EOD
	<div>
	<div class="tcat" style="padding: 3px; margin-top: 3px; margin-bottom: 3px;"><strong><a href="#" onclick="\$('$id').toggle(); return false;">$caption</a></strong></div>
	<div id="$id" class="trow1" style="display:none;">
	$text
	</div>
	</div>
EOD;
	return $out;
}

function bbcode_spoiler_member_replacement($text, $posts = 0) {
	global $lang;
	$lang->load("bbcode_spoiler");

	if (bbcode_spoiler_member_access($posts)) {
		$out = '<div class="trow1" style="margin-top: 3px; margin-bottom: 3px;">' . $text . '</div>';
	} elseif ($posts) {
		$out = '<div class="trow1" style="margin-top: 3px; margin-bottom: 3px;">' . sprintf($lang->members_nr_only, $posts) . '</div>';;
	} else {
		$out = '<div class="trow1" style="margin-top: 3px; margin-bottom: 3px;">' . $lang->members_only . '</div>';;
	}

	return $out;
}

function bbcode_spoiler_member_access($posts) {
	global $mybb;
	return ($mybb->user['uid'] != 0 && (!$posts || $mybb->user['postnum'] > $posts || is_moderator()));
}

function bbcode_spoiler_moder_replacement($text) {
	global $lang;
	$lang->load("bbcode_spoiler");

	if (is_moderator()) {
		$out = <<<EOD
		<div>
		<div class="tcat" style="padding: 3px;"><strong>{$lang->moderator_note}</strong></div>
		<div class="trow1">$text</div>
		</div>
EOD;
	} else {
		$out = '';
	}

	return $out;
}

function bbcode_spoiler_newreply_end() {
	global $message;
	bbcode_spoiler_filter_quotes($message);
}

function bbcode_spoiler_filter_quotes(&$message) {
	$tags = array();
	$tags['\[member\](.*?)\[/member\]'] = 'bbcode_spoiler_member_filter_replacement(trim("$1"))';
	$tags['\[member=(\d+)\](.*?)\[/member\]'] = 'bbcode_spoiler_member_filter_replacement(trim("$2"), "$1")';
	$tags['\[moder\](.*?)\[/moder\]'] = 'bbcode_spoiler_moder_filter_replacement(trim("$1"))';

	foreach ($tags as $pattern => $replacement) {
		$message = preg_replace('#' . $pattern . '#esi', $replacement, $message);
	}
}

function bbcode_spoiler_member_filter_replacement($text, $posts = 0) {
	if (bbcode_spoiler_member_access($posts)) {
		$out = '[member' . ($posts ? "=$posts" : '') . ']' . $text . '[/member]';
	} else {
		$out = '';
	}

	return $out;
}

function bbcode_spoiler_moder_filter_replacement($text) {
	if (is_moderator()) {
		$out = '[moder]' . $text . '[/moder]';
	} else {
		$out = '';
	}

	return $out;
}

function bbcode_spoiler_xmlhttp() {
	global $mybb;
	if($mybb->input['action'] != 'get_multiquoted') return;
	ob_start();

	function bbcode_spoiler_xmlhttp_shutdown() {
		global $message;
		if(!$message) {
			ob_end_flush();
			return;
		}

		ob_end_clean();
		bbcode_spoiler_filter_quotes($message);
		echo $message;
	}

	register_shutdown_function('bbcode_spoiler_xmlhttp_shutdown');
}
?>